# Class SynthTableHeaderUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.TableHeaderUI
javax.swing.plaf.basic.BasicTableHeaderUI
javax.swing.plaf.synth.SynthTableHeaderUI

All Implemented Interfaces:
  `PropertyChangeListener, EventListener, SynthConstants, SynthUI`

public class SynthTableHeaderUI extends BasicTableHeaderUI implements PropertyChangeListener, SynthUI
Provides the Synth L&F UI delegate for `JTableHeader`.

Since:
  1.7

## Nested Class Summary

### Nested classes/interfaces declared in class BasicTableHeaderUI

`BasicTableHeaderUI.MouseInputHandler`
Modifier and Type
Class
Description
`class`
`BasicTableHeaderUI.MouseInputHandler`
This class should be treated as a "protected" inner class.

## Field Summary

### Fields declared in class BasicTableHeaderUI

`header, mouseInputListener, rendererPane`
Modifier and Type
Field
Description
`protected JTableHeader`
`header`
The `JTableHeader` that is delegating the painting to this UI.
`protected MouseInputListener`
`mouseInputListener`
Listeners that are attached to the `JTable`
`protected CellRendererPane`
`rendererPane`
The instance of `CellRendererPane`.

### Fields declared in interface SynthConstants

`DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`
Modifier and Type
Field
Description
`static final int`
`DEFAULT`
Indicates the region is the default.
`static final int`
`DISABLED`
Primary state indicating the region is not enabled.
`static final int`
`ENABLED`
Primary state indicating the component is enabled.
`static final int`
`FOCUSED`
Indicates the region has focus.
`static final int`
`MOUSE_OVER`
Primary state indicating the mouse is over the region.
`static final int`
`PRESSED`
Primary state indicating the region is in a pressed state.
`static final int`
`SELECTED`
Indicates the region is selected.

## Constructor Summary

Constructors
Constructor
Description
`SynthTableHeaderUI()`
Constructs a `SynthTableHeaderUI`.

## Method Summary

Modifier and Type
Method
Description
`static ComponentUI`
`createUI(JComponent h)`
Creates a new UI object for the given component.
`SynthContext`
`getContext(JComponent c)`
Returns the Context for the specified component.
`void`
`paint(Graphics g, JComponent c)`
Paints the specified component according to the Look and Feel.
`protected void`
`paint(SynthContext context, Graphics g)`
Paints the specified component.
`void`
`paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)`
Paints the border.
`void`
`propertyChange(PropertyChangeEvent evt)`
This method gets called when a bound property is changed.
`void`
`update(Graphics g, JComponent c)`
Notifies this UI delegate to repaint the specified component.

### Methods declared in class BasicTableHeaderUI

`createMouseInputListener, getBaseline, getMaximumSize, getMinimumSize, getPreferredSize, getRolloverColumn, installDefaults, installKeyboardActions, installListeners, rolloverColumnUpdated, uninstallDefaults, uninstallKeyboardActions, uninstallListeners`
Modifier and Type
Method
Description
`protected MouseInputListener`
`createMouseInputListener()`
Creates the mouse listener for the `JTableHeader`.
`int`
`getBaseline(JComponent c, int width, int height)`
Returns the baseline.
`Dimension`
`getMaximumSize(JComponent c)`
Return the maximum size of the header.
`Dimension`
`getMinimumSize(JComponent c)`
Return the minimum size of the header.
`Dimension`
`getPreferredSize(JComponent c)`
Return the preferred size of the header.
`protected int`
`getRolloverColumn()`
Returns the index of the column header over which the mouse currently is.
`protected void`
`installDefaults()`
Initializes JTableHeader properties such as font, foreground, and background.
`protected void`
`installKeyboardActions()`
Register all keyboard actions on the JTableHeader.
`protected void`
`installListeners()`
Attaches listeners to the JTableHeader.
`protected void`
`rolloverColumnUpdated(int oldColumn, int newColumn)`
This method gets called every time when a rollover column in the table header is updated.
`protected void`
`uninstallDefaults()`
Uninstalls default properties
`protected void`
`uninstallKeyboardActions()`
Unregisters default key actions.
`protected void`
`uninstallListeners()`
Unregisters listeners.

### Methods declared in class ComponentUI

`contains, getAccessibleChild, getAccessibleChildrenCount, getBaselineResizeBehavior, installUI, uninstallUI`
Modifier and Type
Method
Description
`boolean`
`contains(JComponent c, int x, int y)`
Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
`Accessible`
`getAccessibleChild(JComponent c, int i)`
Returns the `i`th `Accessible` child of the object.
`int`
`getAccessibleChildrenCount(JComponent c)`
Returns the number of accessible children in the object.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior(JComponent c)`
Returns an enum indicating how the baseline of the component changes as the size changes.
`void`
`installUI(JComponent c)`
Configures the specified component appropriately for the look and feel.
`void`
`uninstallUI(JComponent c)`
Reverses configuration which was done on the specified component during `installUI`.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### SynthTableHeaderUI

public SynthTableHeaderUI()
Constructs a `SynthTableHeaderUI`.

## Method Details

### createUI

public static ComponentUI createUI(JComponent h)
Creates a new UI object for the given component.

Parameters:
  `h` - component to create UI object for
Returns:
  the UI object

### update

public void update(Graphics g, JComponent c)
Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `paint(SynthContext,Graphics)` method.

In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

Overrides:
  `update` in class `ComponentUI`
Parameters:
  `g` - the `Graphics` object used for painting
  `c` - the component being painted
See Also:
  - `paint(SynthContext,Graphics)`

### paint

public void paint(Graphics g, JComponent c)
Paints the specified component according to the Look and Feel.

This method is not used by Synth Look and Feel. Painting is handled by the `paint(SynthContext,Graphics)` method.

Overrides:
  `paint` in class `ComponentUI`
Parameters:
  `g` - the `Graphics` object used for painting
  `c` - the component being painted
See Also:
  - `paint(SynthContext,Graphics)`

### paint

protected void paint(SynthContext context, Graphics g)
Paints the specified component.

Parameters:
  `context` - context for the component being painted
  `g` - the `Graphics` object used for painting
See Also:
  - `update(Graphics,JComponent)`

### paintBorder

public void paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)
Paints the border.

Specified by:
  `paintBorder` in interface `SynthUI`
Parameters:
  `context` - a component context
  `g` - `Graphics` to paint on
  `x` - the X coordinate
  `y` - the Y coordinate
  `w` - width of the border
  `h` - height of the border

### getContext

public SynthContext getContext(JComponent c)
Returns the Context for the specified component.

Specified by:
  `getContext` in interface `SynthUI`
Parameters:
  `c` - Component requesting SynthContext.
Returns:
  SynthContext describing component.

### propertyChange

public void propertyChange(PropertyChangeEvent evt)
This method gets called when a bound property is changed.

Specified by:
  `propertyChange` in interface `PropertyChangeListener`
Parameters:
  `evt` - A PropertyChangeEvent object describing the event source and the property that has changed.